%option noyywrap

%top{ 
	
	#pragma warning (disable: 4005)

	#include <iostream>
	#include <cmath>
	
	using namespace std;

	#include "parser.h"

	FILE* pInputFile = NULL;

	extern void close_input_file();

}

NUMB	([0-9]+)|([0-9]*\.[0-9]+)

%%

{NUMB}			{ yylval = atof(yytext); return NUM; }
[+*/()-]		{ return yytext[0]; }
[\n]			{ return '\n'; }
[ \t]			{ /* empty */ }
"quit"			{ yyterminate(); }
.				/* nothing, eat up */
<<EOF>>			{ close_input_file(); yyterminate(); }

%%

void close_input_file()
{
	if(pInputFile)
	{
		fclose(pInputFile);
		pInputFile = NULL;
	}
}

void set_input_file(const char* filename)
{
	if(filename && !fopen_s(&pInputFile, filename, "r"))
	{
		yyin = pInputFile;
	}
}
